package com.example.weatherapi

import ClassifiedSwipeClass
import android.content.Intent
import android.os.Bundle
import android.view.GestureDetector
import android.view.MotionEvent
import android.view.View
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.GestureDetectorCompat

import android.util.Log
import com.example.weatherapi.API.CityName
import com.example.weatherapi.API.Main
import com.example.weatherapi.API.WeatherNowSmall
import com.example.weatherapi.databinding.ActivityMainWeatherBinding
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class MainWeather : AppCompatActivity(), GestureDetector.OnGestureListener {
    private var gestureDetectorCompat: GestureDetectorCompat? = null
    public var _binding : ActivityMainWeatherBinding? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        _binding = ActivityMainWeatherBinding.inflate(layoutInflater)
        setContentView(_binding!!.root)
        gestureDetectorCompat = GestureDetectorCompat(this, this)
        RetrofitConnection.getRetrofit().GetNews(294199, "6qAYnlMXqP3X0HWw60b7Sk3eo8k2D23Z").enqueue(object :
            Callback<Main> {
            override fun onResponse(call: Call<Main>, response: Response<Main>) {

                Log.println(Log.INFO,"t", response.body()!!.Headline.Category.toString())
                _binding!!.textView21.text="View of precipitation: " + response.body()!!.DailyForecasts[0].Day.IconPhrase.toString()
                _binding!!.textView2.text="Type of precipitation: " + response.body()!!.DailyForecasts[0].Day.PrecipitationType.toString()
                _binding!!.textView3.text="The intensity of\nprecipitation: " + response.body()!!.DailyForecasts[0].Day.PrecipitationIntensity.toString()
                _binding!!.textView51.text="View of precipitation: " + response.body()!!.DailyForecasts[0].Night.IconPhrase.toString()
                _binding!!.textView5.text="Type of precipitation: " + response.body()!!.DailyForecasts[0].Night.PrecipitationType.toString()
                _binding!!.textView6.text="The intensity of\nprecipitation: " + response.body()!!.DailyForecasts[0].Night.PrecipitationIntensity.toString()
                _binding!!.textView8.text = response.body()!!.Headline.Category.toString()
                _binding!!.textView9.text="Max.: " + response.body()!!.DailyForecasts[0].Temperature.Maximum.Value.toString() + "°, Min.: " + response.body()!!.DailyForecasts[0].Temperature.Minimum.Value.toString() + "°"
            }

            override fun onFailure(call: Call<Main>, t: Throwable) {
                Log.println(Log.INFO,"t", t.message.toString())
            }
        })
        RetrofitConnection.getRetrofit().GetNews1(294199, "6qAYnlMXqP3X0HWw60b7Sk3eo8k2D23Z").enqueue(object :
            Callback<List<WeatherNowSmall>> {
            override fun onResponse(
                call: Call<List<WeatherNowSmall>>,
                response: Response<List<WeatherNowSmall>>
            ) {
                Log.println(Log.INFO,"ALARM!!!!!!!!!!!!!!!!!!!!!!!!!!!!", response.body()!![0].Temperature.Value.toString())
                _binding!!.textView10.text = response.body()!![0].Temperature.Value.toString() + "°"
            }

            override fun onFailure(call: Call<List<WeatherNowSmall>>, t: Throwable) {
                Log.println(Log.INFO,"A", t.message.toString())
            }


        })
        RetrofitConnection.getRetrofit().GetSearch("6qAYnlMXqP3X0HWw60b7Sk3eo8k2D23Z").enqueue(object :
            Callback<List<CityName>> {
            override fun onResponse(
                call: Call<List<CityName>>,
                response: Response<List<CityName>>
            ) {
                Log.println(Log.INFO,"QQQQQ", response.body()!![0].LocalizedName.toString())
                _binding!!.textView7.text = response.body()!![0].LocalizedName.toString()
            }

            override fun onFailure(call: Call<List<CityName>>, t: Throwable) {
                Log.println(Log.INFO,"QQ", t.message.toString())
            }
        })
    }
    fun onMyButtonClicktwo(view: View?) {

        val intent = Intent (this@MainWeather, WeatherFiveDay::class.java)
        startActivity(intent)
    }
    fun onMyButtonClickone(view: View?) {

        val intent = Intent (this@MainWeather, SearchCityWeather::class.java)
        startActivity(intent)
    }
    override fun onTouchEvent(event: MotionEvent?): Boolean {
        if (event != null) {
            gestureDetectorCompat!!.onTouchEvent(event)
        }
        return super.onTouchEvent(event)
    }

    override fun onDown(e: MotionEvent): Boolean {
        return true
    }

    override fun onShowPress(e: MotionEvent) {
    }

    override fun onSingleTapUp(e: MotionEvent): Boolean {
        return true
    }

    override fun onScroll(
        e1: MotionEvent?,
        e2: MotionEvent,
        distanceX: Float,
        distanceY: Float
    ): Boolean {
        when(ClassifiedSwipeClass (e1!!, e2, distanceX, distanceY)
            .defineSwipe(150)) {
            SwipeVariant.SwipeLeft ->{
                var previousIntent = Intent(this@MainWeather
                    , WeatherFiveDay::class.java);
                previousIntent
                    .addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT)
            }
            SwipeVariant.SwipeRight ->{
                var previousIntent = Intent(this@MainWeather
                    , SearchCityWeather::class.java);
                previousIntent
                    .addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT)
            }
            else -> {
            }
        }
        return true
    }

    override fun onLongPress(e: MotionEvent) {
    }

    override fun onFling(
        e1: MotionEvent?,
        e2: MotionEvent,
        velocityX: Float,
        velocityY: Float
    ): Boolean {
        return true
    }
}
