package com.example.weatherapi

import ClassifiedSwipeClass
import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.view.GestureDetector
import android.view.MotionEvent
import android.view.View
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.GestureDetectorCompat
import androidx.recyclerview.widget.LinearLayoutManager
import com.example.weatherapi.API.CityName
import com.example.weatherapi.API.Main
import com.example.weatherapi.databinding.ActivityMainWeatherBinding
import com.example.weatherapi.databinding.ActivityWeatherFiveDayBinding
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.lang.Math.abs

class WeatherFiveDay : AppCompatActivity(), GestureDetector.OnGestureListener {
    private var gestureDetectorCompat: GestureDetectorCompat? = null
    public var _binding : ActivityWeatherFiveDayBinding? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        _binding = ActivityWeatherFiveDayBinding.inflate(layoutInflater)
        setContentView(_binding!!.root)
        gestureDetectorCompat = GestureDetectorCompat(this, this)
        RetrofitConnection.getRetrofit().GetNews2(294199, "6qAYnlMXqP3X0HWw60b7Sk3eo8k2D23Z").enqueue(object :
            Callback<Main> {
            override fun onResponse(call: Call<Main>, response: Response<Main>) {
                Log.println(Log.INFO,"ALARM", response.body()!!.DailyForecasts.size.toString())
                _binding!!.predictionRecyclerview.layoutManager = LinearLayoutManager(this@WeatherFiveDay, LinearLayoutManager.VERTICAL, false)
                _binding!!.predictionRecyclerview.adapter = prediction_recyclerview_adapter(response.body()!!.DailyForecasts);
            }

            override fun onFailure(call: Call<Main>, t: Throwable) {
                Log.println(Log.INFO,"t", t.message.toString())
            }


        })
        RetrofitConnection.getRetrofit().GetSearch("6qAYnlMXqP3X0HWw60b7Sk3eo8k2D23Z").enqueue(object :
            Callback<List<CityName>> {
            override fun onResponse(
                call: Call<List<CityName>>,
                response: Response<List<CityName>>
            ) {
                Log.println(Log.INFO,"QQQQQ", response.body()!![0].LocalizedName.toString())
                _binding!!.textView11.text = response.body()!![0].LocalizedName.toString()
            }

            override fun onFailure(call: Call<List<CityName>>, t: Throwable) {
                Log.println(Log.INFO,"QQ", t.message.toString())
            }


        })
    }
    fun onMyButtonClicktwo(view: View?) {

        val intent = Intent (this@WeatherFiveDay, MainWeather::class.java)
        startActivity(intent)
    }
    fun onMyButtonClickone(view: View?) {

        val intent = Intent (this@WeatherFiveDay, SearchCityWeather::class.java)
        startActivity(intent)
    }
    override fun onTouchEvent(event: MotionEvent?): Boolean {
        if (event != null) {
            gestureDetectorCompat!!.onTouchEvent(event)
        }
        return super.onTouchEvent(event)
    }

    override fun onDown(e: MotionEvent): Boolean {
        return true
    }

    override fun onShowPress(e: MotionEvent) {
    }

    override fun onSingleTapUp(e: MotionEvent): Boolean {
        return true
    }

    override fun onScroll(
        e1: MotionEvent?,
        e2: MotionEvent,
        distanceX: Float,
        distanceY: Float
    ): Boolean {
        when(ClassifiedSwipeClass (e1!!, e2, distanceX, distanceY)
            .defineSwipe(150)) {
            SwipeVariant.SwipeRight ->{
                var previousIntent = Intent(this@WeatherFiveDay
                    , MainWeather::class.java);
                previousIntent
                    .addFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT)
            }
            else -> {
            }
        }
        return true
    }

    override fun onLongPress(e: MotionEvent) {
    }

    override fun onFling(
        e1: MotionEvent?,
        e2: MotionEvent,
        velocityX: Float,
        velocityY: Float
    ): Boolean {
        return true
    }
}